// bslide -- menu
// (C)Copyright 2004, Yashiro Takeshi

#include <basic.h>
#include <btron/hmi.h>
#include <btron/vobj.h>
#include <btron/libapp.h>
#include "BSlideMenu.h"
#include "tcsliteral.h"
#include "Exceptions.h"

static TC m_finish[]  = {TCS_MENU_FINISH};
static TC m_disp[]    = {TCS_MENU_DISP};
static TC m_penmode[] = {};
static TC m_gonext[]  = {TCS_MENU_GONEXT};
static TC m_goback[]  = {TCS_MENU_GOBACK};
static TC m_jump[]    = {TCS_MENU_JUMP};

static MENUITEM mitems[] = {
  {0L, 0L, 0, 0, m_finish},
  {0L, 0L, 0, 0, m_disp},
  {0L, 0L, 0, 0, m_gonext},
  {0L, 0L, 0, 0, m_goback},
  {0L, 0L, 0, 0, m_jump},  
  {0L, 0L, 0, 0, NULL}, // ɥ
  {0L, 0L, 0, 0, NULL}, // ʪ
};

BSlideMenu::BSlideMenu()
: mid(-1)
{
  typedef std::pair<int, BSlideMenuItem> MConvPair;
  mcnv.insert(std::make_pair(0x001, MN_FINISH));
  mcnv.insert(std::make_pair(0x101, MN_REDISP));
  mcnv.insert(std::make_pair(0x201, MN_GONEXT));
  mcnv.insert(std::make_pair(0x301, MN_GOBACK));
  mcnv.insert(std::make_pair(0x401, MN_JUMP));
  //mcnv.insert(std::make_pair(0x501, MN_WINDOW));
  //mcnv.insert(std::make_pair(0x601, MN_GADGET));
  
  mid = mcre_men(mcnv.size() + 2, mitems, NULL);
  if (mid < 0){
    throw BException((TC[]){TCS_ERROR_MENUOPEN});
  }
}

// #define MENU_WINDOW (mcnv.size() - 2)

// ˥塼ܤμμ
BSlideMenuItem BSlideMenu::getInternalID(int rid) const
{
  int wmidx = mcnv.size();
  int major = rid >> 8;
  if (major == wmidx){
    return MN_WINDOW;
  }
  else if (major == wmidx + 1){
    return MN_GADGET;
  }
  MConvMap::const_iterator p = mcnv.find(rid);
  if (p != mcnv.end()){
    return p->second;
  }
  return MN_VOID;
}

// ˥塼ɥɽ
W BSlideMenu::popupMenu(WEVENT* ev)
{
  int wmidx = mcnv.size();

  wget_dmn(&(mitems[wmidx].ptr));
  mset_itm(mid, wmidx, &(mitems[wmidx]));
  oget_men(0, NULL, &(mitems[wmidx+1].ptr), NULL, NULL);
  mset_itm(mid, wmidx+1, &(mitems[wmidx+1]));
  
  setpointer(PS_SELECT, NULL);
  gdsp_ptr(-1);

  return msel_men(mid, ev->s.pos);
}



