// bslide -- main window
// (C)Copyright 2004, Yashiro Takeshi

#ifndef BSLIDEWINDOW_H
#define BSLIDEWINDOW_H

#include <basic.h>
#include "memgid.h"
#include "LinkCollector.h"
#include "BSlideMenu.h"

class BSlideWindow{
  
private:
  LINK* bsfile;
  LinkCollector link;
  W wid;
  RECT wrect;
  TC* title;
  PAT bgpat;
  BSlideMenu menu;
  BMP screen_bmp;
  GID mgid;
  int currentSlide;
  bool cont;
  void selectMenu(WEVENT* ev, W mitem);
  void redisp(WEVENT* ev);
  void onKeyDown(WEVENT* ev);
  void onMouseButtonDown(WEVENT* ev);
  void onIdle(WEVENT* ev);
  
public:
  
	BSlideWindow(LINK* link = 0);
	virtual ~BSlideWindow(){
    gdsp_ptr(-1);
    display(false);
    release_memgid(&screen_bmp);
  }
  
  W getWindowID() const {
    return wid;
  }
  void display(bool state = true);
  void run();
  void terminate(){
    cont = false;
  }
  void jumpSlide(int index);
  void prevSlide(){
    if (currentSlide <= 0){
      sig_buz(0);
      return;
    }
    jumpSlide(currentSlide-1);
  }
  void nextSlide(){
    if (currentSlide >= link.size()){
      terminate();
      return;
    }
    jumpSlide(currentSlide+1);
  }
};

#endif // BSLIDEWINDOW_H
