// bslide -- parser of options
// (C)Copyright 2004, Yashiro Takeshi

#include "OptionParser.h"
#include "tcsliteral.h"
#include <tcode.h>
#include <bstdio.h>

void OptionParser::putChar(TC ch)
{
  W lang = isTLANGch(ch, &n);
  if (lang > 0){
    currentLang = lang;
    return;
  }
  else if (lang < 0){
    if (lang == -1){
      n = 0;
      currentLang = TSC_SYS;
    }
    return;
  }
  
  n = 0;
  // ѡĲȤ
  switch (currentState){
  case START_OF_LINE:
    if (ch == TK_PCNT && currentLang == TSC_SYS){
      currentState = PERCENT_PARSED;
    }
    else {
      currentState = NONOPTION_LINE;
    }
    break;
  case PERCENT_PARSED:
    if (ch == TK_NL){
      currentState = START_OF_LINE;
      linestack.clear();
      break;
    }
    else if (isspace(ch)){
      break;
    }
    else if (ch == TK_COLN){
      if (linestack.empty()){
        currentState = NONOPTION_LINE;
        break;        
      }
      currentState = COLON_PARSED;
      keytmp = linestack;
      linestack.clear();
      break;
    }
    else if (isalnum(ch) && currentLang == TSC_SYS){
      char buf[2];
      sprintf(buf, "%C", tolower(ch));
      linestack.append(buf);
    }
    break;
  case COLON_PARSED:
    if (ch == TK_NL){
      if (!linestack.empty()){
        //printf("%s : %s\n", keytmp.c_str(), linestack.c_str());
        opts.insert(std::make_pair(keytmp, linestack));
      }
      currentState = START_OF_LINE;
      keytmp.clear();
      linestack.clear();
      break;
    }
    else if (isspace(ch)){
      break;
    }
    else if (isalnum(ch) && currentLang == TSC_SYS){
      char buf[2];
      sprintf(buf, "%C", tolower(ch));
      linestack.append(buf);
    }
    break;
  case NONOPTION_LINE:
    if (ch == TK_NL){
      currentState = START_OF_LINE;
      keytmp.clear();
      linestack.clear();
      break;
    }
    break;
  }
}

SIZE OptionParser::parseSizeOption(const std::string& str)
{
  const SIZE def = {-1, -1};
  SIZE size = {0,0};
  
  bool xparsed = false;
  
  for (int i = 0; i < str.size(); i++){
    if (!xparsed){
      if (str[i] == 'x'){
        xparsed = true;
      }
      else if (str[i] >= '0' && str[i] <= '9'){
        size.h = size.h * 10 + (str[i] - '0');
      }
      else {
        return def;
      }
    }
    else {
      if (str[i] >= '0' && str[i] <= '9'){
        size.v = size.v * 10 + (str[i] - '0');
      }
      else {
        return def;
      }
    }
  }
  return size;
}
