// bslide -- parser of options
// (C)Copyright 2004, Yashiro Takeshi

#ifndef OPTIONPARSER_H
#define OPTIONPARSER_H

#include <string>
#include <map>
#include <basic.h>
#include <tlang.h>

class OptionParser{
  
  typedef enum {
    START_OF_LINE, PERCENT_PARSED, COLON_PARSED, NONOPTION_LINE
  } ParserState;

private:
  std::map<std::string, std::string> opts;
  ParserState currentState;
  std::string keytmp;
  std::string linestack;
  W currentLang;
  W n;

public:

	OptionParser() : currentState(START_OF_LINE), n(0), currentLang(TSC_SYS){}
	virtual ~OptionParser(){}
  
  const std::string& getOption(const std::string& key) const {
    std::map<std::string, std::string>::const_iterator p;
    p = opts.find(key);
    if (p != opts.end()){
      return p->second;
    }
    return "";
  }
  static SIZE parseSizeOption(const std::string& str);
  //static int parseIntOption(const std::string& str) const;
  
  void putChar(TC ch);
};

#endif // OPTIONPARSER_H
