#!/usr/bin/ruby -Ke

require 'jcode'
$KCODE = 'e'

mode = false

print <<EOS
// databox.h (automatically created by mkdbh.rb)
// do not edit this file

#ifndef DEFINE_H_DATABOX
#define DEFINE_H_DATABOX

#define DB_SPNL 0x8000
#define DB_PSTR 0x9000
#define DB_MENU 0xa000
#define DB_SMSG 0xb000
#define DB_MISC 0xf000

EOS

while line = ARGF.gets do
  line.chomp!
  if mode then
    if /\[END_HEADER_CONV\]/ =~ line then
      mode = false
    else
      line.gsub!(/--.*/,'')
      if /\s*(.+?)\s+(.+?)\s*$/ =~ line then
	print "\#define #{$2.upcase} (#{$1.gsub!(/([A-Za-z_]+)/,'DB_\1')})\n"
      end
    end
  else
    if /\[START_HEADER_CONV\]/ =~ line then
      mode = true
    end
  end
end

print <<EOS

#endif // DEFINE_H_DATABOX
EOS
